---
image: "alpine:latest"

workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS
      when: never
    - if: $CI_COMMIT_BRANCH

mr-settings:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
  before_script:
    - apk -q add python3
  script:
    - wget -q "https://gitlab.postmarketos.org/postmarketOS/ci-common/-/raw/master/check_mr_settings.py"
    - python3 ./check_mr_settings.py

ruff:
  image: "alpine:edge"
  before_script:
    - "echo 'https://dl-cdn.alpinelinux.org/alpine/edge/testing' >> /etc/apk/repositories"
    - "adduser -D build"
  script:
    - ".ci/ruff.sh"

vermin:
  before_script:
    - "adduser -D build"
  script:
    - ".ci/vermin.sh"

docs:
  before_script:
    - "adduser -D build"
  script:
    - ".ci/docs.sh"
  artifacts:
    paths:
      - public

deploy:
  only:
    - master
  stage: deploy
  before_script:
    - apk -q add openssh-client rsync
  script:
    - mkdir "${HOME}/.ssh"
    - echo "${SSH_HOST_KEY}" > "${HOME}/.ssh/known_hosts"
    - echo "${SSH_PRIVATE_KEY}" > "${HOME}/.ssh/id_ed25519"
    - chmod 700 "${HOME}/.ssh/id_ed25519"
    - rsync -hrvz --delete -e "ssh -p ${SSH_PORT}" public/ "${SSH_HOST}":/var/www/docs.postmarketos.org/bpo/
  environment:
    name: deploy

pytest:
  image: "alpine:3.18"  # has sqlalchemy<2.0
  before_script:
    - wget "https://gitlab.postmarketos.org/postmarketOS/ci-common/-/raw/master/install_pmbootstrap.sh"
    - PMBOOTSTRAP_TAG=master sh ./install_pmbootstrap.sh
    - ln -s /tmp/pmbootstrap ../pmbootstrap
  script:
    - .ci/pytest.sh
  artifacts:
    when: "on_failure"  # reports artifacts are always uploaded
    paths:
      - "coverage.xml"
      - "_html_out/index.html"
      - "_temp/local_job/task_*.sh"
      - "_temp/local_job_logs/*.txt"
      - "pytest.log"
    reports:
      coverage_report:
        coverage_format: "cobertura"
        path: "coverage.xml"
    expire_in: "1 week"
  coverage: '/(?i)total.*? (100(?:\.0+)?\%|[1-9]?\d(?:\.\d+)?\%)$/'
